var debug = false;
var default_template = "6401136";
var default_orientation = "portrait"; 
var default_language = "de";
var default_rootpath = "none3";
var isAndroid = (/android/gi).test(navigator.appVersion);
var isWindows = (/windows phone 8/gi).test(navigator.appVersion);

var height;// = parseInt( gSysHeight() * window.devicePixelRatio + 0.5 );
var width;// = parseInt( gSysWidth() * window.devicePixelRatio + 0.5 );	


var template, language, tmpl_id;
var orientation, rootPath;

var modify_template = true;		//debug option

//registered Templates
var registeredTemplate = [ 
];

var registeredLanguage = [
	{id:"de"},
	{id:"en"}
];

function gLanguage() {
	var language = navigator.language.split("-"); 
	var root = language[0]; 
	
	if( !isRegisteredLanguage( root ) ) return default_language;
	return root;
}

function gSysWidth() {
	var val=0;
	if( locl.isPhoneGap || !locl.isMobile ) val = window.innerWidth;
		
		
	if( screen.width !=undefined && val==0 ) val = screen.width;
	if( window.innerWidth !=undefined && val==0 ) val = window.innerWidth;
	
	
	if( window.width !=undefined && val==0 ) val = window.width;

	if( locl.iOS ) val = parseInt( val * window.devicePixelRatio + 0.5 );

	return val;
}

function gSysHeight() {
	var val=0;
	if( locl.isPhoneGap || !locl.isMobile ) val = window.innerHeight;
	
	if( screen.height !=undefined && val==0) val = screen.height;
	if( window.innerHeight !=undefined && val==0 ) val = window.innerHeight;
	
	
	if( window.height !=undefined && val==0 ) val = window.height;
	
	if( locl.iOS ) val = parseInt( val * window.devicePixelRatio + 0.5 );
	
	return val;
}

function gSysOrientation() {
	var val = window.orientation;
	if( val==undefined) val = default_orientation;

	//0 liegend 90/-90 stehend portrait
	if( val==90 || val==-90 || val=="landscape" ) {
		return "landscape";
	} else {
		return "portrait";
	}
}

function isRotationLocked() {
	if( !registeredTemplate==undefined ) return false;
	var tmpl_id = getTemplateId( template );
	if( tmpl_id==-1 ) return false;
	return registeredTemplate[tmpl_id].lockRotation;
	
}

function gtHeight() {
	if( !registeredTemplate==undefined ) return false;
	var tmpl_id = getTemplateId( template );
	if( tmpl_id==-1 ) return false;
	
	return registeredTemplate[tmpl_id].height;
	
}

function gtWidth() {
	if( !registeredTemplate==undefined ) return false;
	var tmpl_id = getTemplateId( template );
	if( tmpl_id==-1 ) return false;
	
	return registeredTemplate[tmpl_id].width;
	
}

function isRegisteredTemplate() {
	
	var ret = getTemplateId( template );
	if( ret >= 0 ) {
		debug( "template registered" );
		return true;
	}
	debug( "template not registered: " + ret + ";" + template ); 
	return false;
}

function getTemplateId( tmpl ) {
	for( var i=0; i < registeredTemplate.length; i++ )
		if( registeredTemplate[i].id == tmpl ) return i;

	return -1;
}

function isRegisteredLanguage() {
	for( var i=0; i < registeredLanguage.length; i++ ) 
		if( registeredLanguage[i].id == language ) return true;
	return false;
}

function loadLanguage() {
	language = ""; //gLanguage();
	var setting = locl.language.getSetting();
	
	removeHeadFile( "language_fix" );
	
	if( setting=="auto" ) {
		if( language=="cs" ) {
			language = "cs";
		} else {
	 		language = "cs";
		}
	} else {
		language = setting;
	}
	
	if( language=="" || language==undefined ) language = default_language;
	

	setTimeout( function() {locl.language.load( language );}, 500 );

}

function addTemplateFiles() {
	var path = "templates/" + template;
	var ext;

	//addCSS( path + "/images.css", "images" );
	addJS( path + "/script.js", "script" );
	addCSS( path + "/template.css", "template" );

	if( locl.user.isLogged() ) {
		//css nachladen
		addCSS( path + "/template_logged.css", "template_logged" );
	}
	tmpl_id = getTemplateId( template );
	locl.setTemplate( template, isRotationLocked() );
		
}


function addCSS( file, name ) {
	return;
	ext=document.createElement("link");
	ext.setAttribute("rel", "stylesheet")
	ext.setAttribute("type", "text/css")
	ext.setAttribute("href", file)
	ext.setAttribute("id", name );
	document.getElementsByTagName("head")[0].appendChild(ext);
	
}
function addJS( file, name ) {
	return;
	ext=document.createElement('script');
	ext.setAttribute("type","text/javascript");
	ext.setAttribute("src", file);
	ext.setAttribute("id", name );
	document.getElementsByTagName("head")[0].appendChild(ext);

	
}


function startTemplate() {
	var template_path = "templates/" + template + "/";
	
	locl.setTemplate( template, isRotationLocked() );
}

function UpdateCurrentTemplate() {
	removeHeadFile( "script" );
	removeHeadFile( "template" );
	removeHeadFile( "language_fix" );

	addTemplateFiles();

}

function doDeviceRotation( _width, _height, newVal ) {
	

}

function removeHeadFile( name ){
	var obj = document.getElementById( name );
	if( obj ) obj.parentNode.removeChild( obj );
}

function doOnOrientationChangeInit() {

}


function doOnOrientationChange() {
				
}

var dir_array = [];
function CreateDirs() {
	//dir dir/sub dir/sub1
	//create current
	debug("CreateDirs");
	
	if( locl.isPhoneGap || !locl.isMobile ) return;
	
	window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, SingleDirFSReady, fileTransferFail);
	
}

function SingleDirFSReady( fileSystem ) {
	//create dir	
	//aufbauend!
		for( i=0;i<dir_array.length;i++) {
			current = dir_array[i].subdir;
			debug( "create1 " + current );


			var dirs = current.split("/");
			var last = "";
			for( m=0;m<dirs.length;m++) {
				current = dirs[m];
				
				if( last=="" ) {
					last = current;
				} else {
					last = last + "/" + current;	
				}
				
				debug( "create2 " + last );
				fileSystem.root.getDirectory(last, {create:true,exclusive:false}, directoryCreateSuccess, fileTransferFail); 
			}
			

		}
	
}

function initFS() {
	if( locl.isPhoneGap || !locl.isMobile ) {
		locl.fsReady(  default_rootpath );
	} else {
		window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, 
		function(fileSystem) {
			locl.fsReady( fileSystem.root.fullPath );
			locl.fileSystem = fileSystem;
		}, null);
	}
}

function downloadFinished() {
	locl.Downloader.next();
}


function DownloadFile3( url, subdir ) {	
	var uri = encodeURI( url );
	var filename = basename( url );
	var target = locl.getRootFS() + "/" + subdir + "/" + filename;
	
	if( locl.isPhoneGap || !locl.isMobile ) {
		locl.Downloader.setAsStart( "index_dummy.html" );
		setTimeout( function() {downloadFinished();}, 50);
		return;
	}
		
		
	var fileTransfer = new FileTransfer();
	fileTransfer.download(
	uri,
	target,
	function() { 
	//alert( "done " + uri );
		locl.Downloader.next();					 
	},
	function() {
		locl.Downloader.next();					 
	});

}

function setBackupDir() {
	
	window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, 
		function( fileSystem ) {
				fileSystem.root.getDirectory("Backups", {create:true,exclusive:false},
				function( dirEntry ) {
					directoryCreateSuccess( dirEntry );
				} ,dirFail); 
			
		}, fsFail); 
	
}

function DownloadFile( url, subdir ) {	
	if( locl.isPhoneGap || !locl.isMobile ) {
		locl.Downloader.setAsStart( "index_dummy.html" );
		setTimeout( function() {downloadFinished();}, 100);
		return;
	}
	
	window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, 
		function( fileSystem ) {
			debug("gotFS " + subdir);
			
			var filename = basename( url ); //url.replace(/.*\//, '');
			

			
			var dirs = subdir.split("/");
			var last = "";
			for( m=0;m<dirs.length;m++) {
				current = dirs[m];
				
				if( last=="" ) {
					last = current;
				} else {
					last = last + "/" + current;	
				}
				
				debug( "create2 " + last );
				fileSystem.root.getDirectory(last, {create:true,exclusive:false}, directoryCreateSuccess, fileTransferFail); 
			}
			
			
			
			
			
				fileSystem.root.getDirectory(subdir, {create:true,exclusive:false},
				function( dirEntry ) {
					debug("getDir2 " + filename);
				
					directoryCreateSuccess( dirEntry );

					//setTimeout( function() {
						dirEntry.getFile( filename, {create: true, exclusive: false}, 
						function( fileEntry ) {
							//locl.infoOnline( ( fileEntry.fullPath ) + " (" + i + "/" + t + ")" );
							locl.infoOnline( basename( fileEntry.fullPath ) + " (" + locl.DownloadCache + ")" );

							if( fileEntry.fullPath.indexOf( "index.html" ) >0 ) 
								locl.Downloader.setAsStart( fileEntry.fullPath );	
							
							fileEntry.remove();
							debug("removed");
						
							var uri = encodeURI( url );
														
							//setTimeout( function() {
								var fileTransfer = new FileTransfer();
								fileTransfer.download(
								uri,
								fileEntry.fullPath,
								function() {  
									directoryCreateSuccess( fileEntry );
									
									downloadFinished();									
								},
								function() {
									downloadFinished();								
								});
							//}, 100 );
						
						}, fileFail); 
						//				 }, 100);
					
				} ,dirFail); 
			
		}, fsFail); 
}


function movePic(file){ 
    window.resolveLocalFileSystemURI(file, resolveOnSuccess, resOnError); 
} 

//Callback function when the file system uri has been resolved
function resolveOnSuccess(entry){ 
    //new file name
	
    var newFileName = locl.pages.entriesdetail.fileId;
	if( newFileName =="" ) newFileName = basename( entry.fullPath );
	
    var myFolderApp = "ffinfo";

    window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function(fileSys) {      
    //The folder is created if doesn't exist
    fileSys.root.getDirectory( myFolderApp,
                    {create:true, exclusive: false},
                    function(directory) {
                        entry.moveTo(directory, newFileName,  successMove, resOnError);
                    },
                    resOnError);
                    },
    resOnError);
}

//Callback function when the file has been moved successfully - inserting the complete path
function successMove(entry) {
    //I do my insert with "entry.fullPath" as for the path
	amplify.publish( "page.entriesdetail.imageready", entry.fullPath );
}

function resOnError() {
}


function onSetMetadataSuccess() {
	debug("meta success");	
}

function onSetMetadataFail() {
	debug("meta failed");	
}

function directoryCreateSuccess( dirEntry ) {
	dirEntry.setMetadata(onSetMetadataSuccess, onSetMetadataFail, { "com.apple.MobileBackup": 1});
	debug("creation success");
}

function fileFail(error) {
	downloadFinished();
	debug("fileFail fail: " + error.code);
}
function dirFail(error) {
	downloadFinished();
	debug("dirFail fail: " + error.code);
}

function fsFail() {
	downloadFinished();
}

function fileTransferFail(evt) {
	downloadFinished();
	debug( evt.toSource() );
	locl.networkError();
}

function basename(path) {
	if( path=="" || path==undefined ) return "";

    var file = path.replace(/\\/g,'/').replace( /.*\//, '' );
	
	var new_url;
	if( file.indexOf("&") >-1 ) 
		file = file.substring(0, file.indexOf('&'));
	


	if( file.indexOf("?") >-1 ) 
		file = file.substring(0, file.indexOf('?'));
	
	return file;
	
}
function checkData( data ) {

	if(data == undefined || data=="") return false;
	if(data.length==undefined) return false;
	if(locl.pageId==undefined) return false ;
	//if(locl.pageId=="page") return false;
	return true;
	
}




var incrementCount=0;
var lastGTS=0;
var watchId = null;

function lastGeoTS() {
	var data = locl.db.getLastGeoTS();
	if( data=="" || data==undefined ) {
		var dt = new Date();	
		data = fmtLeading(dt.getDate()) + "." + fmtLeading(dt.getMonth()+1) + "." + dt.getFullYear() + " " + dt.getHours() + ":" + dt.getMinutes() + ":" + dt.getSeconds();
	}
	return data;
	
}
function getGEOPosition() {
	lastGTS = lastGeoTS();
	incrementCount=0;
	
	getGeo2();  
	//getGeo3();
}

function getGeo2() {
	var options = {
	  enableHighAccuracy: true,
	  timeout: 20000,
	  maximumAge: 0
	};
	
	watchId = navigator.geolocation.watchPosition( onSuccessGEO, onErrorGEO, options );
	
}


function getGeo() {	
	locl.showLoading( g("_LANG_DATA_LOADING_MSG") + "... " + incrementCount );
	
	var options = {
	  enableHighAccuracy: true,
	  timeout: 20000,
	  maximumAge: 0
	};

	if( incrementCount==100 ) {
		locl.pages.guidenearme.onGeoRet();
		return;
	}
	navigator.geolocation.getCurrentPosition(
		 function( position ) {
			var dt = new Date(position.timestamp);
			ts = fmtLeading(dt.getDate()) + "." + fmtLeading(dt.getMonth()+1) + "." + dt.getFullYear() + " " + dt.getHours() + ":" + dt.getMinutes() + ":" + dt.getSeconds();

			if( ts==lastGTS || incrementCount<=10 ) {
				incrementCount++;
				setTimeout( function() {getGeo();}, 700 );
			} else {
				locl.db.saveLastGeoTS( ts );
				onSuccessGEO( position );
			}
		 }, onErrorGEO, options);

	
	
}

function getGeo3() {	
	var options = {
	  enableHighAccuracy: true,
	  timeout: 5000,
	  maximumAge: 0
	};

	navigator.geolocation.getCurrentPosition(onSuccessGEO, onErrorGEO, options);
	
}


function onSuccessGEO(position) {	
	var lat = position.coords.latitude;
	var lon = position.coords.longitude; 
	
	clearWatch();
	
	locl.geo.geoRet( lon, lat );
}

function clearWatch() {
	navigator.geolocation.clearWatch( watchId );
	watchId = null;	
}

function onErrorGEO(error) { 
	clearWatch();
	locl.geo.onGeoErr( error ); 		
	
}


function fmtLeading( num ) {
num += "";
if( num.length==1 ) return "0" + num;	
return num;

}

function getDateFromString( datestr ) {
	var day = datestr.substr(0,2);
	var month = datestr.substr(3,2);
	var year = datestr.substr(6,4);
	var dt = new Date( year, (month-1), day );
	// 01.03.2013 = beginnt bei 0!
	return dt;
}

function AddDays(date, amount)
{
	var tzOff = date.getTimezoneOffset() * 60 * 1000;
	var t = date.getTime();
	t += (1000 * 60 * 60 * 24) * amount;
	var d = new Date();
	d.setTime(t);
	var tzOff2 = d.getTimezoneOffset() * 60 * 1000;
	if (tzOff != tzOff2)
	{
		var diff = tzOff2 - tzOff;
		t += diff;
		d.setTime(t);
	}
	return d;

}

function is_numeric(n) {
  return !isNaN(parseFloat(n)) && isFinite(n);
}

